/*
Copyright (c) 2010, Stephane Duguay < s (@) binarez (.) com >
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and
the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions
and the following disclaimer in the documentation and/or other materials provided with the distribution.
* Neither the name of the <ORGANIZATION> nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef TOUCH_EXE_FILE_CRAWLER_H
#define TOUCH_EXE_FILE_CRAWLER_H

#include <string>
#include <queue>
#include <windows.h>

class FileCrawler
{
public:
						FileCrawler( const std::wstring& absTarget, bool recursive );
						~FileCrawler( void );
	
public:
	void				getCurrentFilename( std::wstring& absFilename ) const;
	bool				nextFile( void );
	bool				gotFiles( void ) const;

private:
	bool				nextFileInternal( void );
	bool				nextFileSubCrawl( void );
	void				die( void );
	void				detectSubDirectories( const std::wstring& currentAbsDir, const std::wstring& currentFilter );

private:
	HANDLE								mhFindFiles;
	WIN32_FIND_DATA						mCurrentFileInfo;
	std::wstring						mTargetAbs;
	std::wstring						mCurrentAbsDir;
	std::wstring						mCurrentFilter;
	
	typedef std::queue< FileCrawler * > SubCrawlers;
	SubCrawlers							mSubCrawlers;
	FileCrawler*						mpActiveSubCrawler;

	bool								mRecursive;
};

#endif // TOUCH_EXE_FILE_CRAWLER_H
