/*
Copyright (c) 2010, Stephane Duguay < s (@) binarez (.) com >
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and
the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions
and the following disclaimer in the documentation and/or other materials provided with the distribution.
* Neither the name of the <ORGANIZATION> nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef TOUCH_EXE_TOUCH_TIME_H
#define TOUCH_EXE_TOUCH_TIME_H

//------------------------------------------------------------------------------------------------//
#include <windows.h>
#include <string>
//------------------------------------------------------------------------------------------------//
class TouchOptions;
//------------------------------------------------------------------------------------------------//
class TouchTime
{
public:
						TouchTime( void );
						~TouchTime( void );

public:
	enum eLoadResult	{	Success = 1,
							ErrMultiSources,
							ErrInvalidTimestamp,
							ErrInvalidDateTime,
							ErrInvalidRefFile,
							ErrSystemTimeFailure	};
public:
	eLoadResult			loadFromOptions( const TouchOptions& touchOptions );
	void				reset();

public:
	FILETIME			mCreationTime;
	FILETIME			mAccessTime;
	FILETIME			mModifTime;

private:
	bool				loadFromReferenceFile( const std::wstring& absRefFile );
	bool				loadFromTimestamp( const std::wstring& timestamp );
	bool				loadFromDateTime( const std::wstring& dateTime );
};
//------------------------------------------------------------------------------------------------//

#endif // TOUCH_EXE_TOUCH_TIME_H
